## ubuntu-image 1.11+20.04ubuntu1

=== debian/changelog ===
ubuntu-image (1.11+20.04ubuntu1) focal; urgency=medium

  [ Michael Vogt ]
  * Use "resolved-content" directory provided by newer versions
    of "snap prepare-image". (LP:1636927)

  [ Brian Murray ]
  * Fix a typo in README.rst.

  [ Łukasz 'sil2100' Zemczak ]
  * Add a workaround for mkfs.ext4 forcefully sparsifying our classic image
    swapfile (LP:1900718)
  * Add python3.9 to the test envlists.
  * Minor README fixups and additions, minor test-related compatibility
    changes.

  [ Sebastien Bacher ]
  * setup.py:
    - get the version in a way which is compatible with the current
      python-debian
  * SRU tracking number LP: #1920955

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 25 Mar 2021 14:55:14 +0100

ubuntu-image (1.10+20.04ubuntu1) focal; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * SRU tracking number LP: #1896744
  * Add a quick option to disable console-conf.  (LP:1866002)
  * Disable some of the unsupported features for UC20 models.  (LP:1875431)
    - --disable-console-conf
    - --cloud-init
    - Running the post-populate-rootfs hook.
  * Do not create an empty /boot on the system-seed partition.
  * Switch the approach of building UC20 images to ensure that all partitions
    defined in the gadget are considered in image size calculations.
    (LP:1859973)

  [ Michael Hudson-Doyle ]
  * Add dependency on fdisk now that it is no longer Essential.  (LP:1877485)

  [ Maciej Borzecki ]
  * Do not overwrite the files that snap prepare-image has created.
    (LP:1884247)

  [ Dimitri John Ledkov ]
  * Pacify flake8 in groovy.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 03 Sep 2020 10:20:28 +0200

## ubuntu-image 1.11+20.04ubuntu1.1

=== debian/changelog ===
ubuntu-image (1.11+20.04ubuntu1.1) focal; urgency=medium

  * Fix autopkgtests failures in d/t/mount due to errors:
    'no snap revision available as specified' (LP: #2044508)
    - d/t/models/*.manifest: add .manifest files for model assertions:
      (from https://cdimage.ubuntu.com/ubuntu-core/16/stable/current )
      - pc-amd64-model.manifest    (ubuntu-core-16-amd64.manifest)
      - dragonboard-model.manifest (ubuntu-core-16-dragonboard.manifest)
      - pc-i386-model.manifest     (ubuntu-core-16-i386.manifest)
      - pi2-model.manifest         (ubuntu-core-16-pi2.manifest)
      - pi3-model.manifest         (ubuntu-core-16-pi3.manifest)
    - d/t/mount: specify snap revisions per the .manifest files

 -- Mauricio Faria de Oliveira <mfo@canonical.com>  Fri, 24 Nov 2023 07:45:55 -0300

=== debian/control ===
Source: ubuntu-image
Section: utils
Priority: optional
Maintainer: Lukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
Build-Depends: debhelper (>= 9),
               dh-python,
               dosfstools,
               fdisk | util-linux (<< 2.29.2-3),
               gdisk,
               grub-common,
               livecd-rootfs,
               mtools,
               python3-all,
               python3-attr,
               python3-coverage,
               python3-debian,
               python3-docutils,
               python3-flake8,
               python3-nose2,
               python3-parted,
               python3-pkg-resources,
               python3-setuptools,
               python3-voluptuous,
               python3-yaml,
               snapd (>= 2.38~),
               tox,
Standards-Version: 3.9.8
Homepage: http://launchpad.net/ubuntu-image

Package: ubuntu-image
Architecture: all
Depends: python3-ubuntu-image (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
Description: toolkit for building Ubuntu images.
 .
 This package contains the ubuntu-image program.

Package: python3-ubuntu-image
Architecture: all
Section: python
Depends: ca-certificates,
         dosfstools,
         fdisk | util-linux (<< 2.29.2-3),
         gdisk,
         grub-common,
         livecd-rootfs (>= 2.480),
         fakeroot,
         mtools (>= 4.0.18-2ubuntu0),
         python3-attr,
         python3-parted,
         python3-pkg-resources,
         python3-setuptools,
         python3-voluptuous,
         python3-yaml,
         snapd (>= 2.38~),
         ${misc:Depends},
         ${python3:Depends},
Suggests: qemu-user-static,
Description: toolkit for building Ubuntu images
 .
 This package contains the ubuntu-image library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=ubuntu-image
#export PYBUILD_VERBOSE=1
#export DH_VERBOSE=1

export UBUNTU_IMAGE_TESTS_NO_NETWORK=1
export pkgversion=$(shell dpkg-parsechangelog --show-field version)

%:
	dh $@ --with=python3 --buildsystem=pybuild

# Override dh_install to ensure that /usr/bin/ubuntu-image is in the dedicated
# package.
override_dh_install:
	dh_install
	mkdir -p debian/ubuntu-image/usr/bin
	mv debian/python3-ubuntu-image/usr/bin/ubuntu-image \
	   debian/ubuntu-image/usr/bin/

override_dh_installman:
	rst2man ubuntu-image.rst debian/ubuntu-image.1
	dh_installman

# Run the bare minimum of tests during build.  The majority of the tests will
# run during the autopkgtests.
override_dh_auto_test:
	dh_auto_test -- --system=custom \
		--test-args='{interpreter} -m nose2 -vv'

override_dh_auto_clean:
	rm -f debian/ubuntu-image.1
	dh_auto_clean

## ubuntu-image 1.11+20.10ubuntu1

=== debian/changelog ===
ubuntu-image (1.11+20.10ubuntu1) groovy; urgency=medium

  [ Michael Vogt ]
  * Use "resolved-content" directory provided by newer versions
    of "snap prepare-image". (LP:1636927)
  * SRU tracking number LP: #1920955

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 25 Mar 2021 14:55:14 +0100

ubuntu-image (1.10+20.10ubuntu4) hirsute; urgency=medium

  * Add python3.9 to the test envlists.
  * Minor README fixups and additions, minor test-related compatibility
    changes.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 13 Jan 2021 11:27:53 +0100

ubuntu-image (1.10+20.10ubuntu3) hirsute; urgency=medium

  * setup.py:
    - get the version in a way which is compatible with the current
      python-debian

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 26 Nov 2020 15:30:53 +0100

## ubuntu-image 1.11+21.04ubuntu2

=== debian/changelog ===
ubuntu-image (1.11+21.04ubuntu2) hirsute; urgency=medium

  * Refreshed manpage.
  * debian/control: remove the explicit grub-common dependency in
    python3-ubuntu-image.  This was added as a workaround for snapd using
    grub-editenv without an explicit dependency - but since long they switched
    to using a native implementation instead.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 09 Apr 2021 11:14:38 +0200

ubuntu-image (1.11+21.04ubuntu1) hirsute; urgency=medium

  [ Michael Vogt ]
  * Use "resolved-content" directory provided by newer versions
    of "snap prepare-image". (LP: #1636927)

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 25 Mar 2021 14:55:14 +0100

=== debian/control ===
--- 
+++ 
@@ -43,7 +43,6 @@
          dosfstools,
          fdisk | util-linux (<< 2.29.2-3),
          gdisk,
-         grub-common,
          livecd-rootfs (>= 2.480),
          fakeroot,
          mtools (>= 4.0.18-2ubuntu0),

## ubuntu-image 2.2+22.04ubuntu2

=== debian/changelog ===
ubuntu-image (2.2+22.04ubuntu2) jammy; urgency=medium

  * Fix failing autopkgtests:
    - Restrict test using snap prepare-image --arch=amd64 to only run on amd64
    - Increase size of 4k volume to have enough sectors to be valid fat32

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Wed, 13 Apr 2022 10:49:05 -0500

ubuntu-image (2.2+22.04ubuntu1) jammy; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * Allow for no fstab in the rootfs for classic image builds.

  [ William 'jawn-smith' Wilson ]
  * Fix use of --snap flag with the --filesystem flag (LP: #1958275)
  * Fix bug with attempting to create partition with no content
  * Fix edge cases with custom gadget.yaml (LP: #1968205)

  [ Alfonso Sanchez-Beato ]
  * Add support for the piboot bootloader (LP: #1965585)

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 18 Mar 2022 17:15:10 +0100

ubuntu-image (2.1+22.04ubuntu3) jammy; urgency=medium

  * Update tests to reflect changes in the hello snap

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Thu, 13 Jan 2022 22:40:24 -0600

ubuntu-image (2.1+22.04ubuntu2) jammy; urgency=medium

  * Create rootfs partitions with OffsetWrite nil instead of zero
    (LP: #1954850)

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Tue, 14 Dec 2021 17:13:45 -0600

ubuntu-image (2.1+22.04ubuntu1) jammy; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * Make sure the generated disk IDs are unique.
  * Add support for specifying a disk sector-size to use while building the
    images (LP: #1942416)

  [ William 'jawn-smith' Wilson ]
  * Pull in upstream change from go-diskfs to fix integer overflows on armhf
    (LP: #1949208)
  * Add logic to name system-data partitions "writable" if a name isn't
    specified (LP: #1951334)
  * Fix logic for filesystem labeling in /etc/fstab (LP: #1950677)
  * Add --validation flag (LP: #1933665)

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Tue, 02 Nov 2021 12:57:01 -0500

ubuntu-image (2.0+22.04ubuntu3) jammy; urgency=medium

  * Disable some tests on some architectures. This resolves failures
    caused by snaps not being available on certain architectures, and 
    a few other scenarios where not every test is applicable.

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Fri, 22 Oct 2021 15:35:18 -0500

ubuntu-image (2.0+22.04ubuntu2) jammy; urgency=medium

  * go.mod: use git-meta tag for snapcore/bolt to pull in latest
    riscv64 changes. Resolves riscv64 build failure.

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Thu, 21 Oct 2021 09:32:10 -0500

ubuntu-image (2.0+22.04ubuntu1) jammy; urgency=medium

  [ William 'jawn-smith' Wilson ]
  * Re-write ubuntu-image in Go to improve integration with snapd
    - Remove -o / --output option that has been deprecated for years
    - The command line option --hooks-directory must now be specified
      once per hooks directory, rather than a comma separated list.
    - ubuntu-image no longer defaults to the 'snap' subcommand and requires
      specifying the exact build mode to use.

  [ Łukasz 'sil2100' Zemczak ]
  * debian/control: as we're replacing the python ubuntu-image version,
    force removal of the no-longer used python3-ubuntu-image via a Conflicts
    stanza.

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Mon, 26 Apr 2021 15:33:22 -0500

=== debian/control ===
Source: ubuntu-image
Section: utils
Priority: optional
Maintainer: Lukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
Build-Depends: debhelper (>= 11),
               dh-golang (>= 1.17~),
               fdisk,
               gdisk,
               golang-go (>= 2:1.13~),
               livecd-rootfs,
               mtools,
               python3-docutils,
               snapd,
Standards-Version: 4.1.2
Homepage: http://launchpad.net/ubuntu-image

Package: ubuntu-image
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: ${shlibs:Depends},
         ${misc:Depends},
         fdisk,
         gdisk,
         livecd-rootfs,
         mtools,
         snapd,
Conflicts: python3-ubuntu-image
Description: Toolkit for building Ubuntu images.
 Ubuntu Image is the official tool for building various Ubuntu images according
 to the provided specification - both core and classic.

=== debian/tests/control ===
Tests: run-tests
Restrictions: needs-root, isolation-machine, allow-stderr
Depends: @builddeps@,
         qemu-user-static [!ppc64el !s390x]

## ubuntu-image 2.2+22.04ubuntu3

=== debian/changelog ===
ubuntu-image (2.2+22.04ubuntu3) jammy; urgency=medium

  [ William 'jawn-smith' Wilson ]
  * Add lintian overrides for test files

  [ Maciej Borzecki ]
  * Pull in a newer snapd version and load snaps from all modes (LP: #1969979)

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Wed, 13 Apr 2022 16:28:11 -0500

## ubuntu-image 2.2+22.04ubuntu3.22.04.1

=== debian/changelog ===
ubuntu-image (2.2+22.04ubuntu3.22.04.1) jammy-security; urgency=medium

  * No change build due to golang-1.18 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 28 Apr 2023 12:51:41 +0530

## ubuntu-image 2.2+22.04ubuntu3.22.04.2

=== vendor/github.com/diskfs/go-diskfs/Makefile ===
.PHONY: test image unit_test

PACKAGE_NAME?=github.com/diskfs/go-diskfs
IMAGE ?= diskfs/go-diskfs:build
GOENV ?= GO111MODULE=on CGO_ENABLED=0
GO_FILES ?= $(shell $(GOENV) go list ./...)
GOBIN ?= $(shell go env GOPATH)/bin
LINTER ?= $(GOBIN)/golangci-lint


# BUILDARCH is the host architecture
# ARCH is the target architecture
# we need to keep track of them separately
BUILDARCH ?= $(shell uname -m)
BUILDOS ?= $(shell uname -s | tr A-Z a-z)

# canonicalized names for host architecture
ifeq ($(BUILDARCH),aarch64)
BUILDARCH=arm64
endif
ifeq ($(BUILDARCH),x86_64)
BUILDARCH=amd64
endif

# unless otherwise set, I am building for my own architecture, i.e. not cross-compiling
# and for my OS
ARCH ?= $(BUILDARCH)
OS ?= $(BUILDOS)

# canonicalized names for target architecture
ifeq ($(ARCH),aarch64)
        override ARCH=arm64
endif
ifeq ($(ARCH),x86_64)
    override ARCH=amd64
endif

BUILD_CMD = CGO_ENABLED=0 GOOS=$(OS) GOARCH=$(ARCH)
ifdef DOCKERBUILD
BUILD_CMD = docker run --rm \
                -e GOARCH=$(ARCH) \
                -e GOOS=linux \
                -e CGO_ENABLED=0 \
                -v $(CURDIR):/go/src/$(PACKAGE_NAME) \
                -w /go/src/$(PACKAGE_NAME) \
                $(BUILDER_IMAGE)
endif

image:
	docker build -t $(IMAGE) testhelper/docker

# because we keep making the same typo
unit-test: unit_test
unit_test:
	@$(GOENV) go test $(GO_FILES)

test: image
	TEST_IMAGE=$(IMAGE) $(GOENV) go test $(GO_FILES)

golangci-lint: $(LINTER)
$(LINTER):
	curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOBIN) v1.41.0


## Check the file format
fmt-check:
	@if [ -n "$(shell $(BUILD_CMD) gofmt -l ${GO_FILES})" ]; then \
	  $(BUILD_CMD) gofmt -s -e -d ${GO_FILES}; \
	  exit 1; \
	fi

## Lint the files
lint: golangci-lint
	@$(BUILD_CMD) $(LINTER) run --disable-all --enable=revive ./...

## Vet the files
vet:
	@$(BUILD_CMD) go vet ${GO_FILES}

=== debian/changelog ===
ubuntu-image (2.2+22.04ubuntu3.22.04.2) jammy-security; urgency=medium

  * No change rebuild due to golang-1.18 update

 -- Allen Huang <allen.huang@canonical.com>  Fri, 15 Nov 2024 17:41:43 +0000

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = optimize=-lto
export DH_GOPKG := github.com/canonical/ubuntu-image

# strict symbols checking
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

PKGVERSION=$(shell dpkg-parsechangelog --show-field version)
BUILDFLAGS+= -buildmode=pie -ldflags "-X main.Version=$(PKGVERSION)"
builddir = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)
artifactsdir = $(builddir)/build

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_clean:
	dh_auto_clean
	# create the vendor directory when building the source package
	[ -d vendor/ ] || go mod vendor

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_installman:
	mkdir -p $(artifactsdir)
	rst2man ubuntu-image.rst $(artifactsdir)/ubuntu-image.1
	dh_installman

override_dh_auto_test:

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)

override_dh_missing:
	dh_missing --fail-missing

## ubuntu-image 2.2+22.04ubuntu3.22.10.1

=== debian/changelog ===
ubuntu-image (2.2+22.04ubuntu3.22.10.1) kinetic-security; urgency=medium

  * No change build due to golang-1.18 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 28 Apr 2023 12:53:12 +0530

## ubuntu-image 2.2+22.10ubuntu1

=== debian/changelog ===
ubuntu-image (2.2+22.10ubuntu1) lunar; urgency=medium

  [ Pawel Stolowski ]
  * Add support for uc20 preseeding-related options.

  [ William 'jawn-smith' Wilson ]
  * Update to latest snapd that supports snapcraft v7 credentials
    (LP: #1984014)
  * Fix issue with partitions not being sized properly when using
    --image-size (LP: #1981744)
  * Create filesystems with content when the content was created by
    ubuntu-image (LP: #1981720)
  * Fix map ordering bug in populate_bootfs_contents step
  * Update to latest snapd volume layout API (LP: #1990979)

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Wed, 08 Jun 2022 10:25:57 -0500

## ubuntu-image 2.2+22.10ubuntu2

=== debian/changelog ===
ubuntu-image (2.2+22.10ubuntu2) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:18:43 +1200

## ubuntu-image 2.2+22.10ubuntu2.1

=== debian/changelog ===
ubuntu-image (2.2+22.10ubuntu2.1) mantic-security; urgency=medium

  * No change rebuild due to golang-1.20, golang-1.21 updates

 -- Nishit Majithia <nishit.majithia@canonical.com>  Thu, 01 Feb 2024 14:08:15 +0530
